#include "cm_jparser.h"
#include "cm_utils.h"

static const struct json_obj_descr json_descriptor[] = {
  JSON_OBJ_DESCR_PRIM(json_data_t , set_vout_mv , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , set_max_i_in_ma , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , set_max_i_out_ma , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , set_max_temp_in , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , set_max_temp_out , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , get_vin_mv , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , get_vout_mv , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , get_i_in_ma , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , get_i_out_ma , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , get_temp_in , JSON_TOK_NUMBER ),
  JSON_OBJ_DESCR_PRIM(json_data_t , get_temp_out , JSON_TOK_NUMBER )
};

#define JSON_DESC_CNT sizeof(json_descriptor)/sizeof(json_descriptor[0])

int64_t cm_jparser( char * instr , size_t str_len , json_data_t * values )
{
    int64_t result_code;

    result_code = json_obj_parse( instr , str_len , json_descriptor , JSON_DESC_CNT , values );
    // printk("Parse result code: " PRINTF_BINARY_PATTERN_INT64 "\n", PRINTF_BYTE_TO_BINARY_INT64(result_code));
    return result_code;
}
