// Process a message that has been parsed by the JSON parser

#include "cm_mproc.h"
#include "cm_jparser.h"
#include "cm_utils.h"
#include "cm_write_vout.h"
#include "cm_read_analog.h"

// #include <zephyr/kernel.h>
// #include <zephyr/device.h>
// #include <zephyr/devicetree.h>
#include <zephyr/drivers/gpio.h>


message_error_t cm_message_proc_init( void ) {
    return MESSAGE_OK;
}


message_error_t cm_mproc( int64_t flags , json_data_t * message ) {

    message_error_t return_code = MESSAGE_OK;

    // printk("Change flags: " PRINTF_BINARY_PATTERN_INT64 "\n", PRINTF_BYTE_TO_BINARY_INT64(flags));

    // Try an analog read...
    int32_t result;
    cm_read_analog_mv( ANA_SRC_V_IN , &result );
    printk("Read V_IN = %dmv\n",result);

    // Go through all the message flags and take action as appropriate
    for( int var_index = 0 ; var_index < JSON_DATA_CNT ; var_index++ ) {
        if( test_bit_int64( flags , var_index ) ) {
            switch( var_index ) {
                case 0: // JSON message index 0
                printk("Setting V_OUT to %d mV\n",message->set_vout_mv);
                return_code = cm_write_vout_mv(message->set_vout_mv);
                if( return_code != MESSAGE_OK ) {
                    return( return_code );
                }
                break;

                default:
                printk("Unable to handle variable at index %d\n",var_index);
                break;
            }
        }
    }
    return( return_code );
}